package index

import (
	"context"
	"hongze/mysteel_watch/global"
	"hongze/mysteel_watch/models/base"
	"time"
)

// 钢联化工指标数据
type BaseFromMysteelChemicalData struct {
	BaseFromMysteelChemicalDataId  int64     `gorm:"primaryKey;column:base_from_mysteel_chemical_data_id" json:"base_from_mysteel_chemical_data_id"` //序号
	BaseFromMysteelChemicalIndexId int64     `gorm:"column:base_from_mysteel_chemical_index_id" json:"base_from_mysteel_chemical_index_id"`
	IndexCode                      string    `gorm:"column:index_code" json:"index_code"`
	DataTime                       time.Time `gorm:"column:data_time" json:"data_time"`
	Value                          string    `gorm:"column:value" json:"value"`
	UpdateDate                     string    `gorm:"column:update_date" json:"update_date"`
	base.TimeBase
}

// TableName get sql table name.获取数据库表名
func (r *BaseFromMysteelChemicalData) TableName() string {
	return "base_from_mysteel_chemical_data"
}

// 新增
func (r *BaseFromMysteelChemicalData) Add(runMod string, list []BaseFromMysteelChemicalData) (err error) {
	if runMod == "release" {
		err = global.MYSQL["hzdata"].Create(list).Error
		return
	} else {
		err = global.DEFAULT_MYSQL.Create(list).Error
		return
	}
}

// 修改
func (r *BaseFromMysteelChemicalData) Update(runMod string, updateCols []string) (err error) {
	if runMod == "release" {
		err = global.MYSQL["hzdata"].Model(r).Select(updateCols).Updates(r).Error
		return
	} else {
		err = global.DEFAULT_MYSQL.Model(r).Select(updateCols).Updates(r).Error
		return
	}
}

func (d *BaseFromMysteelChemicalData) GetIndexDataList(runMod string, indexCode string) (item []*BaseFromMysteelChemicalData, err error) {
	if runMod == "release" {
		err = global.MYSQL["hzdata"].WithContext(context.TODO()).Model(d).
			Where("index_code = ?", indexCode).Find(&item).Error
		return
	} else {
		err = global.DEFAULT_MYSQL.WithContext(context.TODO()).Model(d).
			Where("index_code = ?", indexCode).Find(&item).Error
		return
	}
}
